diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-primary-channels-test.cc ns-3.43/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.42/src/wifi/test/wifi-primary-channels-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-primary-channels-test.cc	2024-10-09 16:41:10.140657000 -0700
@@ -1,23 +1,13 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
 
 #include "ns3/ap-wifi-mac.h"
+#include "ns3/attribute-container.h"
 #include "ns3/boolean.h"
 #include "ns3/config.h"
 #include "ns3/ctrl-headers.h"
@@ -64,10 +54,10 @@
     /**
      * Constructor
      *
-     * \param channelWidth the operating channel width (in MHz)
+     * \param channelWidth the operating channel width
      * \param useDistinctBssColors whether to set distinct BSS colors to BSSes
      */
-    WifiPrimaryChannelsTest(uint16_t channelWidth, bool useDistinctBssColors);
+    WifiPrimaryChannelsTest(MHz_u channelWidth, bool useDistinctBssColors);
     ~WifiPrimaryChannelsTest() override;
 
     /**
@@ -88,43 +78,40 @@
      * transmission channel width
      *
      * \param bss the given BSS
-     * \param txChannelWidth the given transmission channel width in MHz
+     * \param txChannelWidth the given transmission channel width
      */
-    void SendDlSuPpdu(uint8_t bss, uint16_t txChannelWidth);
+    void SendDlSuPpdu(uint8_t bss, MHz_u txChannelWidth);
     /**
      * Have the AP of the given BSS transmit a MU PPDU using the given
      * transmission channel width and RU type
      *
      * \param bss the given BSS
-     * \param txChannelWidth the given transmission channel width in MHz
+     * \param txChannelWidth the given transmission channel width
      * \param ruType the given RU type
      * \param nRus the number of RUs
      */
-    void SendDlMuPpdu(uint8_t bss, uint16_t txChannelWidth, HeRu::RuType ruType, std::size_t nRus);
+    void SendDlMuPpdu(uint8_t bss, MHz_u txChannelWidth, HeRu::RuType ruType, std::size_t nRus);
     /**
      * Have the AP of the given BSS transmit a Basic Trigger Frame. This method calls
      * DoSendHeTbPpdu to actually have STAs transmit HE TB PPDUs using the given
      * transmission channel width and RU type
      *
      * \param bss the given BSS
-     * \param txChannelWidth the given transmission channel width in MHz
+     * \param txChannelWidth the given transmission channel width
      * \param ruType the given RU type
      * \param nRus the number of RUs
      */
-    void SendHeTbPpdu(uint8_t bss, uint16_t txChannelWidth, HeRu::RuType ruType, std::size_t nRus);
+    void SendHeTbPpdu(uint8_t bss, MHz_u txChannelWidth, HeRu::RuType ruType, std::size_t nRus);
     /**
      * Have the STAs of the given BSS transmit an HE TB PPDU using the given
      * transmission channel width and RU type
      *
      * \param bss the given BSS
-     * \param txChannelWidth the given transmission channel width in MHz
+     * \param txChannelWidth the given transmission channel width
      * \param ruType the given RU type
      * \param nRus the number of RUs
      */
-    void DoSendHeTbPpdu(uint8_t bss,
-                        uint16_t txChannelWidth,
-                        HeRu::RuType ruType,
-                        std::size_t nRus);
+    void DoSendHeTbPpdu(uint8_t bss, MHz_u txChannelWidth, HeRu::RuType ruType, std::size_t nRus);
     /**
      * Callback invoked when a station receives a DL PPDU.
      *
@@ -167,9 +154,9 @@
      * they operate on, otherwise.
      *
      * \param txBss the set of BSSes that transmitted an SU PPDU
-     * \param txChannelWidth the given transmission channel width in MHz
+     * \param txChannelWidth the given transmission channel width
      */
-    void CheckReceivedSuPpdus(std::set<uint8_t> txBss, uint16_t txChannelWidth);
+    void CheckReceivedSuPpdus(std::set<uint8_t> txBss, MHz_u txChannelWidth);
     /**
      * Check that (i) all stations/APs belonging to the given BSSes received the DL/UL MU PPDUs
      * transmitted over the given channel width and RU width; and (ii) stations/APs belonging to
@@ -178,13 +165,13 @@
      * performed on a channel adjacent to the one they operate on, otherwise.
      *
      * \param txBss the set of BSSes that transmitted an SU PPDU
-     * \param txChannelWidth the given transmission channel width in MHz
+     * \param txChannelWidth the given transmission channel width
      * \param ruType the given RU type
      * \param nRus the number of RUs
      * \param isDlMu true for DL MU PPDU, false for HE TB PPDU
      */
     void CheckReceivedMuPpdus(std::set<uint8_t> txBss,
-                              uint16_t txChannelWidth,
+                              MHz_u txChannelWidth,
                               HeRu::RuType ruType,
                               std::size_t nRus,
                               bool isDlMu);
@@ -195,15 +182,15 @@
      * channel and all the primary20 channels are distinct).
      *
      * \param txBss the set of BSSes that transmitted a Trigger Frame
-     * \param txChannelWidth the given transmission channel width in MHz
+     * \param txChannelWidth the given transmission channel width
      */
-    void CheckReceivedTriggerFrames(std::set<uint8_t> txBss, uint16_t txChannelWidth);
+    void CheckReceivedTriggerFrames(std::set<uint8_t> txBss, MHz_u txChannelWidth);
 
   private:
     void DoSetup() override;
     void DoRun() override;
 
-    uint16_t m_channelWidth;                      ///< operating channel width in MHz
+    MHz_u m_channelWidth;                         ///< operating channel width
     bool m_useDistinctBssColors;                  ///< true to set distinct BSS colors to BSSes
     uint8_t m_nBss;                               ///< number of BSSes
     uint8_t m_nStationsPerBss;                    ///< number of stations per AP
@@ -219,7 +206,7 @@
     Time m_triggerTxDuration;                 ///< TX duration for Basic Trigger Frame
 };
 
-WifiPrimaryChannelsTest::WifiPrimaryChannelsTest(uint16_t channelWidth, bool useDistinctBssColors)
+WifiPrimaryChannelsTest::WifiPrimaryChannelsTest(MHz_u channelWidth, bool useDistinctBssColors)
     : TestCase("Check correct transmissions for various primary channel settings"),
       m_channelWidth(channelWidth),
       m_useDistinctBssColors(useDistinctBssColors)
@@ -333,7 +320,7 @@
 
     // we create as many stations per BSS as the number of 26-tone RUs in a channel
     // of the configured width
-    switch (m_channelWidth)
+    switch (static_cast<uint16_t>(m_channelWidth))
     {
     case 20:
         m_nStationsPerBss = 9;
@@ -390,13 +377,16 @@
                 "WaitBeaconTimeout",
                 TimeValue(MicroSeconds(102400))); // same as BeaconInterval
 
-    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue> channelValue;
+    AttributeContainerValue<
+        TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
+        ';'>
+        channelValue;
 
     // Each BSS uses a distinct primary20 channel
     for (uint8_t bss = 0; bss < m_nBss; bss++)
     {
         channelValue.Set(
-            WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, bss});
+            WifiPhy::ChannelSegments{{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, bss}});
         phy.Set("ChannelSettings", channelValue);
 
         m_staDevices.push_back(wifi.Install(phy, mac, wifiStaNodes[bss]));
@@ -405,7 +395,7 @@
     for (uint8_t bss = 0; bss < m_nBss; bss++)
     {
         channelValue.Set(
-            WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, bss});
+            WifiPhy::ChannelSegments{{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, bss}});
         phy.Set("ChannelSettings", channelValue);
 
         mac.SetType("ns3::ApWifiMac",
@@ -420,10 +410,10 @@
     }
 
     // Assign fixed streams to random variables in use
-    streamNumber = wifi.AssignStreams(m_apDevices, streamNumber);
+    streamNumber = WifiHelper::AssignStreams(m_apDevices, streamNumber);
     for (uint8_t bss = 0; bss < m_nBss; bss++)
     {
-        streamNumber = wifi.AssignStreams(m_staDevices[bss], streamNumber);
+        streamNumber = WifiHelper::AssignStreams(m_staDevices[bss], streamNumber);
     }
 
     // set BSS color
@@ -469,7 +459,7 @@
     m_triggerTxVector = WifiTxVector(OfdmPhy::GetOfdmRate6Mbps(),
                                      0,
                                      WIFI_PREAMBLE_LONG,
-                                     800,
+                                     NanoSeconds(800),
                                      1,
                                      1,
                                      0,
@@ -618,7 +608,7 @@
     // To have simultaneous transmissions on adjacent channels, just initialize
     // nRounds to 1 and nApsPerRound to m_channelWidth / 20. Of course, the test
     // will fail because some stations will not receive some frames due to interfence
-    for (uint16_t txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
+    for (MHz_u txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
          txChannelWidth <= m_channelWidth;
          txChannelWidth *= 2, nRounds *= 2, nApsPerRound /= 2)
     {
@@ -654,7 +644,7 @@
      * channel width, every round is repeated as many times as the number of ways in
      * which we can partition the transmission channel width in equal sized RUs.
      */
-    for (uint16_t txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
+    for (MHz_u txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
          txChannelWidth <= m_channelWidth;
          txChannelWidth *= 2, nRounds *= 2, nApsPerRound /= 2)
     {
@@ -702,7 +692,7 @@
      * channel width, every round is repeated as many times as the number of ways in
      * which we can partition the transmission channel width in equal sized RUs.
      */
-    for (uint16_t txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
+    for (MHz_u txChannelWidth = 20, nRounds = 2, nApsPerRound = m_channelWidth / 20 / 2;
          txChannelWidth <= m_channelWidth;
          txChannelWidth *= 2, nRounds *= 2, nApsPerRound /= 2)
     {
@@ -762,7 +752,7 @@
 }
 
 void
-WifiPrimaryChannelsTest::SendDlSuPpdu(uint8_t bss, uint16_t txChannelWidth)
+WifiPrimaryChannelsTest::SendDlSuPpdu(uint8_t bss, MHz_u txChannelWidth)
 {
     NS_LOG_INFO("*** BSS " << +bss << " transmits on primary " << txChannelWidth << " MHz channel");
 
@@ -773,7 +763,7 @@
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs8(),
                                          0,
                                          WIFI_PREAMBLE_HE_SU,
-                                         800,
+                                         NanoSeconds(800),
                                          1,
                                          1,
                                          0,
@@ -795,7 +785,7 @@
 
 void
 WifiPrimaryChannelsTest::SendDlMuPpdu(uint8_t bss,
-                                      uint16_t txChannelWidth,
+                                      MHz_u txChannelWidth,
                                       HeRu::RuType ruType,
                                       std::size_t nRus)
 {
@@ -809,7 +799,7 @@
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs8(),
                                          0,
                                          WIFI_PREAMBLE_HE_MU,
-                                         800,
+                                         NanoSeconds(800),
                                          1,
                                          1,
                                          0,
@@ -840,7 +830,7 @@
     }
     txVector.SetSigBMode(VhtPhy::GetVhtMcs5());
     RuAllocation ruAllocations;
-    auto numRuAllocs = txChannelWidth / 20;
+    const std::size_t numRuAllocs = txChannelWidth / 20;
     ruAllocations.resize(numRuAllocs);
     auto IsOddNum = (nRus / numRuAllocs) % 2 == 1;
     auto ruAlloc = HeRu::GetEqualizedRuAllocation(ruType, IsOddNum);
@@ -852,7 +842,7 @@
 
 void
 WifiPrimaryChannelsTest::SendHeTbPpdu(uint8_t bss,
-                                      uint16_t txChannelWidth,
+                                      MHz_u txChannelWidth,
                                       HeRu::RuType ruType,
                                       std::size_t nRus)
 {
@@ -876,7 +866,7 @@
 
 void
 WifiPrimaryChannelsTest::DoSendHeTbPpdu(uint8_t bss,
-                                        uint16_t txChannelWidth,
+                                        MHz_u txChannelWidth,
                                         HeRu::RuType ruType,
                                         std::size_t nRus)
 {
@@ -895,7 +885,7 @@
     WifiTxVector trigVector(HePhy::GetHeMcs8(),
                             0,
                             WIFI_PREAMBLE_HE_TB,
-                            3200,
+                            NanoSeconds(3200),
                             1,
                             1,
                             0,
@@ -920,7 +910,7 @@
         WifiTxVector txVector(HePhy::GetHeMcs8(),
                               0,
                               WIFI_PREAMBLE_HE_TB,
-                              3200,
+                              NanoSeconds(3200),
                               1,
                               1,
                               0,
@@ -972,7 +962,7 @@
 }
 
 void
-WifiPrimaryChannelsTest::CheckReceivedSuPpdus(std::set<uint8_t> txBss, uint16_t txChannelWidth)
+WifiPrimaryChannelsTest::CheckReceivedSuPpdus(std::set<uint8_t> txBss, MHz_u txChannelWidth)
 {
     for (uint8_t bss = 0; bss < m_nBss; bss++)
     {
@@ -1051,7 +1041,7 @@
 
 void
 WifiPrimaryChannelsTest::CheckReceivedMuPpdus(std::set<uint8_t> txBss,
-                                              uint16_t txChannelWidth,
+                                              MHz_u txChannelWidth,
                                               HeRu::RuType ruType,
                                               std::size_t nRus,
                                               bool isDlMu)
@@ -1173,8 +1163,7 @@
 }
 
 void
-WifiPrimaryChannelsTest::CheckReceivedTriggerFrames(std::set<uint8_t> txBss,
-                                                    uint16_t txChannelWidth)
+WifiPrimaryChannelsTest::CheckReceivedTriggerFrames(std::set<uint8_t> txBss, MHz_u txChannelWidth)
 {
     for (uint8_t bss = 0; bss < m_nBss; bss++)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-ru-allocation-test.cc ns-3.43/src/wifi/test/wifi-ru-allocation-test.cc
--- ns-3.42/src/wifi/test/wifi-ru-allocation-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-ru-allocation-test.cc	2024-10-09 16:41:10.140657000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -45,14 +34,10 @@
      *
      * \param primary20 the index of the primary20 channel to configure
      * \param ru the given RU
-     * \param width the width in MHz of the channel to which the given RU refers to; normally,
-     *              it is the width in MHz of the PPDU for which the RU is allocated
-     * \param indices the expected indices
+     * \param width the width of the channel to which the given RU refers to; normally, it is the
+     * width of the PPDU for which the RU is allocated \param indices the expected indices
      */
-    void RunOne(uint8_t primary20,
-                HeRu::RuSpec ru,
-                uint16_t width,
-                const std::set<uint8_t>& indices);
+    void RunOne(uint8_t primary20, HeRu::RuSpec ru, MHz_u width, const std::set<uint8_t>& indices);
 
   private:
     void DoRun() override;
@@ -68,7 +53,7 @@
 void
 Wifi20MHzIndicesCoveringRuTest::RunOne(uint8_t primary20,
                                        HeRu::RuSpec ru,
-                                       uint16_t width,
+                                       MHz_u width,
                                        const std::set<uint8_t>& indices)
 {
     auto printToStr = [](const std::set<uint8_t>& s) {
@@ -103,7 +88,7 @@
 
     /* 20 MHz PPDU */
     {
-        const uint16_t width = 20;
+        const MHz_u width = 20;
         const uint8_t p20Index = 0;
 
         // All the 9 26-tone RUs are covered by the unique 20 MHz channel
@@ -133,7 +118,7 @@
     /* 20 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 2; p20Index++)
     {
-        const uint16_t width = 20;
+        const MHz_u width = 20;
 
         // All the 9 26-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
@@ -157,7 +142,7 @@
     /* 40 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 2; p20Index++)
     {
-        const uint16_t width = 40;
+        const MHz_u width = 40;
 
         // The first 9 26-tone RUs are covered by the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
@@ -205,7 +190,7 @@
     /* 20 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 4; p20Index++)
     {
-        const uint16_t width = 20;
+        const MHz_u width = 20;
 
         // All the 9 26-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
@@ -229,7 +214,7 @@
     /* 40 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 4; p20Index++)
     {
-        const uint16_t width = 40;
+        const MHz_u width = 40;
         // PPDU is transmitted on P40, which may be in the lower or higher 40 MHz
         const uint8_t p40Index = p20Index / 2;
         // RUs can be allocated in one (or both) of the two 20 MHz channels in P40
@@ -277,7 +262,7 @@
     /* 80 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 4; p20Index++)
     {
-        const uint16_t width = 80;
+        const MHz_u width = 80;
 
         // The first 9 26-tone RUs are in the first 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
@@ -365,7 +350,7 @@
     /* 20 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 8; p20Index++)
     {
-        const uint16_t width = 20;
+        const MHz_u width = 20;
 
         // All the 9 26-tone RUs are covered by the primary 20 MHz channel
         for (std::size_t idx = 1; idx <= 9; idx++)
@@ -389,7 +374,7 @@
     /* 40 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 8; p20Index++)
     {
-        const uint16_t width = 40;
+        const MHz_u width = 40;
         // PPDU is transmitted on P40, which is one of the four 40 MHz channels
         const uint8_t p40Index = p20Index / 2;
         // RUs can be allocated in one (or both) of the two 20 MHz channels in P40
@@ -437,7 +422,7 @@
     /* 80 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 8; p20Index++)
     {
-        const uint16_t width = 80;
+        const MHz_u width = 80;
         // PPDU is transmitted on P80, which is one of the two 80 MHz channels
         const uint8_t p80Index = p20Index / 4;
         // RUs can be allocated in one (or more) of the four 20 MHz channels in P80
@@ -530,7 +515,7 @@
     /* 160 MHz PPDU */
     for (uint8_t p20Index = 0; p20Index < 8; p20Index++)
     {
-        const uint16_t width = 160;
+        const MHz_u width = 160;
 
         for (auto primary80MHz : {true, false})
         {
